using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using Excel = Microsoft.Office.Interop.Excel;

namespace AddinAndExcelUDFExample
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("520893DA-F0BB-48F2-81E1-DEDDDB3D1F5F"), ProgId("AddinAndExcelUDFExample.AddinModule")]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            InitializeComponent();
        }

        private AddinExpress.MSO.ADXCommandBar adxCommandBar1;
        private AddinExpress.MSO.ADXCommandBarButton adxCommandBarButton1;
 
        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;
 
        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            this.adxCommandBar1 = new AddinExpress.MSO.ADXCommandBar(this.components);
            this.adxCommandBarButton1 = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            // 
            // adxCommandBar1
            // 
            this.adxCommandBar1.CommandBarName = "Excel Bar";
            this.adxCommandBar1.CommandBarTag = "987024a7-5f49-42f2-9d14-b8397b826305";
            this.adxCommandBar1.Controls.Add(this.adxCommandBarButton1);
            this.adxCommandBar1.Position = AddinExpress.MSO.ADXMsoBarPosition.adxMsoBarTop;
            this.adxCommandBar1.UpdateCounter = 4;
            // 
            // adxCommandBarButton1
            // 
            this.adxCommandBarButton1.Caption = "Just a test";
            this.adxCommandBarButton1.ControlTag = "b55a6025-53c3-4b18-b77c-b184c7f38bfc";
            this.adxCommandBarButton1.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxCommandBarButton1.UpdateCounter = 3;
            this.adxCommandBarButton1.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.adxCommandBarButton1_Click);
            // 
            // AddinModule
            // 
            this.AddinName = "AddinAndExcelUDFExample";
            this.ShimProgID = "AddinAndExcelUDFExampleShim.Proxy";
            this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaExcel;

        }
        #endregion
 
        #region ADX automatic code
 
        // Required by Add-in Express - do not modify
        // the methods within this region
 
        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }
 
        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }
 
        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }
 
        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        public Excel._Application ExcelApp
        {
            get
            {
                return (HostApplication as Excel._Application);
            }
        }

        private void adxCommandBarButton1_Click(object sender)
        {
            MessageBox.Show("Hello. I am add-in.");
        }

    }
}

